<!DOCTYPE html>
<html>

<head>
  <title>Courses CRUD</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <!-- Vùng header -->
  <div class="container-fluid">
    <div class="text-center">
      <h2>Quản trị Courses</h2>
    </div>
    <div class="form-group">
      <button class="btn btn-success" id="btn-add-course"><i class="fa fa-plus"></i>&nbsp; New Course</button>
    </div>
  </div>
  <!-- Vouche Data Table -->
  <div class="container-fluid">
    <table class="table table-bordered table-striped table-hover" id="courses-table">
      <thead>
        <tr>
          <th>ID</th>
          <th>Code</th>
          <th>Title</th>
          <th>Price</th>
          <th>Discount</th>
          <th>Duration</th>
          <th>Level</th>
          <th>Cover</th>
          <th>Teacher</th>
          <th>Avatar</th>
          <th>Popular</th>
          <th>Trending</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>
  <!-- Vùng Modal -->

  <!-- Create courses modal -->
  <div>
    <div id="create-course-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Create new course</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-code">Course Code</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-code" name="courseCode" placeholder="Chứa ít nhất 10 ký tự"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-name">Course Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-name" name="courseName" placeholder="Chứa ít nhất 20 ký tự"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-price">Listed Price</label>
                </div>
                <div class="col-sm-8">
                  <input type="number" id="input-create-price" name="price" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-duration">Duration</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-duration" name="duration" placeholder="0h 00m"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-level">Level</label>
                </div>
                <div class="col-sm-8">
                  <select id="select-create-level" name="level" class="form-control">
                    <option value="Beginner">Beginner</option>
                    <option value="Intermediate">Intermediate</option>
                    <option value="Advanced">Advanced</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-teacher">Teacher Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-teacher" name="teacherName"
                    placeholder="Tên đầy đủ của giảng viên" class="form-control">
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-create-course">Create Course</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Update voucher modal -->
  <div>
    <div id="update-course-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Update a Course</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-name">Course Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-name" name="courseName" placeholder="Chứa ít nhất 20 ký tự"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-discount">Discount Price</label>
                </div>
                <div class="col-sm-8">
                  <input type="number" id="input-update-discount" name="discountPrice" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-duration">Duration</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-duration" name="duration" placeholder="0h 00m"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-level">Level</label>
                </div>
                <div class="col-sm-8">
                  <select id="select-update-level" name="level" class="form-control">
                    <option value="Beginner">Beginner</option>
                    <option value="Intermediate">Intermediate</option>
                    <option value="Advanced">Advanced</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-cover">Cover Image</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-cover" name="coverImage"
                    placeholder="images/courses/course-abcxyz.jpg" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-teacher">Teacher Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-teacher" name="teacherName"
                    placeholder="Tên đầy đủ của giảng viên" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-avatar">Teacher Photo</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-avatar" name="teacherPhoto"
                    placeholder="images/teacher/abc_xyz.jpg" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-avatar">Popular</label>
                  <input type="checkbox" id="cbox-update-popular" name="isPopular">
                </div>
                <div class="col-sm-8">
                  <label for="input-update-avatar">Trending</label>
                  <input type="checkbox" id="cbox-update-trending" name="isTrending">
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-update-course">Update Course</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Course Delete Confirmation</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa course này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete">Confirm</button>
            <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Biến toàn cục để lưu trữ id course đang đc update or delete. Mặc định = 0;
  var gCourseId = 0;
  var gCoursePrice = 0;

  const gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";
  const gCONTENT_TYPE = "application/json;charset=UTF-8";

  // Khai báo DataTable & mapping collumns
  var gCoursesTable = $("#courses-table").DataTable({
    columns: [
      { data: "id" },
      { data: "courseCode" },
      { data: "courseName" },
      { data: "price" },
      { data: "discountPrice" },
      { data: "duration" },
      { data: "level" },
      { data: "coverImage" },
      { data: "teacherName" },
      { data: "teacherPhoto" },
      { data: "isPopular" },
      { data: "isTrending" }
    ],
    columnDefs: [
      {
        targets: 7,
        render: function (data) {
          return "<img class='img-thumbnail' src=" + data + ">";
        }
      },
      {
        targets: 9,
        render: function (data) {
          return "<img class='rounded-circle w-75' src=" + data + ">";
        }
      },
      { // định nghĩa lại cột action
        targets: 12,
        defaultContent: `
        <img title="edit-course" class="edit-course" style="width: 20px;cursor:pointer;"
          src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png">
        <img title="delete-course" class="delete-course" style="width: 20px;cursor:pointer;"
          src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png">
      `
      }
    ]
  });

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    // thực hiện tải trang
    onPageLoading();

    // 2 - C: gán sự kiện Create - Thêm mới course
    $("#btn-add-course").click(onBtnAddNewCourseClick);

    // 3 - U: gán sự kiện Update - Sửa 1 course
    $("#courses-table").on("click", ".edit-course", function () {
      onBtnEditCourseClick(this);
    });
    // 4 - D: gán sự kiện Delete - Delete 1 course
    $("#courses-table").on("click", ".delete-course", function () {
      onBtnDeleteCourseClick(this);
    });

    // gán sự kiện cho nút Create course (trên modal)
    $("#btn-create-course").click(onBtnCreateCourseClick);

    // gán sự kiện cho nút Update course (trên modal)
    $("#btn-update-course").click(onBtnUpdateCourseClick);

    // gán sự kiện cho nút Delete course (trên modal)
    $("#btn-confirm-delete").click(onBtnConfirmDelCourseClick);

  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm thực thi khi trang được load
  function onPageLoading() {
    // 1 - R: Read / Load courses to DataTable
    getAllCourses();
  }

  // Hàm xử lý sự kiện khi nút Thêm mới đc click
  function onBtnAddNewCourseClick() {
    // hiển thị modal trắng lên
    $("#create-course-modal").modal("show");
  }

  // Hàm xử lý sự kiện khi icon edit voucher trên bảng đc click
  function onBtnEditCourseClick(paramBtnEdit) {
    // lưu thông tin courseId đang được edit vào biến toàn cục
    gCourseId = getCourseIdFromButton(paramBtnEdit);
    // load dữ liệu vào các trường dữ liệu trong modal
    getCourseById(gCourseId);
  }

  // Hàm xử lý sự kiện khi icon delete course trên bảng đc click
  function onBtnDeleteCourseClick(paramBtnDel) {
    // lưu thông tin courseId đang được delete vào biến toàn cục
    gCourseId = getCourseIdFromButton(paramBtnDel);
    // hiển thị modal lên
    $("#delete-confirm-modal").modal("show");
  }

  // hàm xử lý sự kiện create course modal click
  function onBtnCreateCourseClick() {
    // khai báo đối tượng chứa course data
    var vCourseObj = {
      courseCode: "",
      courseName: "",
      price: gCoursePrice,
      discountPrice: gCoursePrice,
      duration: "",
      level: "",
      teacherName: ""
    };
    // B1: Thu thập dữ liệu
    getCreateCourseData(vCourseObj);
    // B2: Validate insert
    var vIsCourseValidate = validateCourseData(vCourseObj);
    if (vIsCourseValidate) {
      // B3: insert course
      $.ajax({
        url: gBASE_URL + "/courses",
        type: "POST",
        contentType: gCONTENT_TYPE,
        data: JSON.stringify(vCourseObj),
        success: handleInsertCourseSuccess, // B4: xử lý front-end
        error: function (paramErr) {
          alert(paramErr.status);
        }
      });
    }
  }

  // hàm xử lý sự kiện update course modal click
  function onBtnUpdateCourseClick() {
    // khai báo đối tượng chứa course data
    var vCourseObjRequest = {
      courseName: "",
      price: gCoursePrice,
      discountPrice: gCoursePrice,
      duration: "",
      level: "",
      coverImage: "",
      teacherName: "",
      teacherPhoto: "",
      isPopular: false,
      isTrending: false
    };
    // B1: Thu thập dữ liệu
    getUpdateCourseData(vCourseObjRequest);
    // B2: Validate update
    var vIsCourseValidate = validateCourseData(vCourseObjRequest);
    if (vIsCourseValidate) {
      // B3: update course
      $.ajax({
        url: gBASE_URL + "/courses/" + gCourseId,
        type: "PUT",
        contentType: gCONTENT_TYPE,
        data: JSON.stringify(vCourseObjRequest),
        success: handleUpdateCourseSuccess, // B4: xử lý front-end
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
  }

  // hàm xử lý sự kiện confirm course modal click
  function onBtnConfirmDelCourseClick() {
    // delete course
    $.ajax({
      url: gBASE_URL + "/courses/" + gCourseId,
      type: "DELETE",
      success: handleDeleteCourseSuccess, // xử lý front-end
      error: function (paramErr) {
        console.log(paramErr.status);
      }
    });
  }


  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm gọi api để lấy all danh sách courses đăng ký
  function getAllCourses() {
    $.ajax({
      url: gBASE_URL + "/courses",
      type: "GET",
      success: loadDataToCoursesTable,
      error: function (paramErr) {
        alert(paramErr.status);
      }
    });
  }
  /** load courses array to DataTable
   * in: courses array
   * out: courses table has data
   */
  function loadDataToCoursesTable(res) {
    gCoursesTable.clear();
    gCoursesTable.rows.add(res);
    gCoursesTable.draw();
  }

  // hàm get course by id
  function getCourseById(paramCourseId) {
    $.ajax({
      url: gBASE_URL + "/courses/" + paramCourseId,
      type: "GET",
      success: showCourseDataToModal,
      error: function (paramErr) {
        console.log(paramErr.status);
      }
    });
    // hiển thị modal lên
    $("#update-course-modal").modal("show");
  }

  // hàm show course obj lên modal
  function showCourseDataToModal(paramCourse) {
    gCoursePrice = paramCourse.price;
    $("#input-update-name").val(paramCourse.courseName);
    $("#input-update-discount").val(paramCourse.discountPrice);
    $("#input-update-duration").val(paramCourse.duration);
    $("#select-update-level").val(paramCourse.level);
    $("#input-update-cover").val(paramCourse.coverImage);
    $("#input-update-teacher").val(paramCourse.teacherName);
    $("#input-update-avatar").val(paramCourse.teacherPhoto);
    $("#cbox-update-popular").attr("checked", paramCourse.isPopular);
    $("#cbox-update-trending").attr("checked", paramCourse.isTrending);
  }

  // hàm thu thập dữ liệu để create Course
  function getCreateCourseData(paramCourseObj) {
    paramCourseObj.courseCode = $("#input-create-code").val().trim();
    paramCourseObj.courseName = $("#input-create-name").val().trim();
    paramCourseObj.price = parseInt($("#input-create-price").val());
    paramCourseObj.discountPrice = parseInt($("#input-create-price").val());
    paramCourseObj.duration = $("#input-create-duration").val().trim();
    paramCourseObj.level = $("#select-create-level").val();
    paramCourseObj.teacherName = $("#input-create-teacher").val().trim();
  }

  // hàm thu thập dữ liệu để update Course
  function getUpdateCourseData(paramCourseObj) {
    paramCourseObj.courseName = $("#input-update-name").val().trim();
    paramCourseObj.discountPrice = parseInt($("#input-update-discount").val());
    paramCourseObj.duration = $("#input-update-duration").val().trim();
    paramCourseObj.level = $("#select-update-level").val();
    paramCourseObj.coverImage = $("#input-update-cover").val().trim();
    paramCourseObj.teacherName = $("#input-update-teacher").val().trim();
    paramCourseObj.teacherPhoto = $("#input-update-avatar").val().trim();
    paramCourseObj.isPopular = $("#cbox-update-popular").prop("checked");
    paramCourseObj.isTrending = $("#cbox-update-trending").prop("checked");
  }

  // hàm validate data
  function validateCourseData(paramCourseObj) {
    var price = paramCourseObj.price;
    var discount = paramCourseObj.discountPrice;

    for (const key in paramCourseObj) {
      if (paramCourseObj[key] === "") {
        alert("Fill Information");
        return false;
      }
    }

    if (isNaN(price) || price <= 0) {
      alert("Price cần nhập vào");
      return false;
    }

    if (discount < 0 || discount > price) {
      alert("Discount phải nhập trong khoảng từ 0 đến Price!");
      return false;
    }

    return true;
  }

  // hàm xử lý hiển thị front-end khi thêm course thành công
  function handleInsertCourseSuccess() {
    alert("Thêm course thành công!");
    getAllCourses();
  }

  // hàm xử lý hiển thị front-end khi sửa course thành công
  function handleUpdateCourseSuccess() {
    alert("Sửa course thành công!");
    getAllCourses();
    $("#update-course-modal").modal("hide");
  }

  // hàm xử lý hiển thị front-end khi delete course thành công
  function handleDeleteCourseSuccess() {
    alert("Delete course thành công!");
    getAllCourses();
    $("#delete-confirm-modal").modal("hide");
  }

  // hàm dựa vào button detail (edit or delete) xác định đc id course
  function getCourseIdFromButton(paramButton) {
    var vTableRow = $(paramButton).parents("tr");
    var vCourseRowData = gCoursesTable.row(vTableRow).data();
    return vCourseRowData.id;
  }

</script>

</html>